/* 
===============================================================================

Copyright (C) 2001  Sergei Hristov Kostov             Bulgaria    city: Razgrad 

  
  This file is part of S(imple)view free software; you can redistribute it 
  and/or modify it under the terms of the GNU General Public License as 
  published by the Free Software Foundation; either version 2 of the 
  License, or any later version.
	    
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
	    
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

 See COPYING for more details.

Last modified : 30.07.2001

version 0.1 release 010730



===============================================================================
*/


#include "vroutines.cpp"
#include <unistd.h>
#include <SDL/SDL_keysym.h>
#include <gtk-1.2/gtk/gtk.h>

SDL_Surface *screen;
const SDL_VideoInfo *bestmode;
SDL_Event event;
SDL_Surface *image;    
GtkWidget *filew,*helpwin;
int YES;
char *selected_file;
     
  struct aview_flags
     {
      int aview_quit;
      Uint32 screenflags;
      int count;
     }view;



   void SDL_bmp_to_screen(SDL_Surface *src_image,SDL_Surface *dest_screen)
	 {
	  if (src_image->format->palette && dest_screen->format->palette) 
	      {
		SDL_SetColors(dest_screen, src_image->format->palette->colors, 0,
		src_image->format->palette->ncolors);
	      };
	  if(SDL_BlitSurface(src_image, NULL, dest_screen, NULL) < 0)
	    { 
	     Error(SDL_GetError(),0);
	     return;
	     };
	   SDL_UpdateRect(dest_screen, 0, 0, src_image->w, src_image->h);
	  };     	
	
   
   void SDL_video_ini(void)
	 {
	 if( SDL_Init(SDL_INIT_VIDEO) < 0 )
	               {
		          Error(SDL_GetError(),1);
		       };
	 atexit(SDL_Quit);
	 };
 

   SDL_Surface* video_ini(int x,int y,int depth)
	{
	   SDL_Surface *ini_screen;

	ini_screen = SDL_SetVideoMode(x, y, depth,view.screenflags|SDL_SWSURFACE|SDL_ANYFORMAT);
	if ( ini_screen == NULL )
	       {
	       Error(SDL_GetError(),1);
	       };
	  return ini_screen;
	 };
	
    
    void display_image(char *file_name)
	    {
	     SDL_WM_SetCaption("LOADING... PLEASE WAIT!",NULL);
	     image=IMG_Load(file_name);
	       if (image==NULL)
		{
		 Error("Hmm...",1);
		};
	    if (image->w<50)
	      {
	       if (image->format->BitsPerPixel<bestmode->vfmt->BitsPerPixel)
	       screen=video_ini(image->w+50,image->h,image->format->BitsPerPixel);
		else
	    screen=video_ini(image->w+50,image->h,bestmode->vfmt->BitsPerPixel);
	      } 
	     else 
	       if (image->format->BitsPerPixel<bestmode->vfmt->BitsPerPixel)
		 screen=video_ini(image->w,image->h,image->format->BitsPerPixel);
		  else
		 screen=video_ini(image->w,image->h,bestmode->vfmt->BitsPerPixel);
	      SDL_bmp_to_screen(image,screen);
	      SDL_WM_SetCaption("S(imply)view  by Sergei Kostov .BG",NULL);
	     };
	     
      
	     
   void destroy( GtkWidget *widget,gpointer   data )
        {
	    gtk_widget_destroy(filew);
	    gtk_main_quit ();
	};
	
	     
   void for_me( GtkWidget *w,GtkFileSelection *fs)
    {
      const char *buf;
      buf=gtk_file_selection_get_filename (GTK_FILE_SELECTION (fs));
      if ( chdir(buf)<0 )
      { 
      /*if (Is_Supported(buf)==1)
           {
	    Imagelist_Add_New();  AAAAAAA why is that not workIIIIIIIIIIIng 
	    selected_file=gtk_file_selection_get_filename (GTK_FILE_SELECTION (fs));
	    image_names->name=selected_file;
	    Imagelist_To_first();
	    gtk_widget_destroy(filew);
	    gtk_main_quit();YES=1; PROBABLY A BUG IN THE GTK CAUSE I TRACED IT
	   }
	   else 
	   {return;};*/
      return;}
	else
      { get_namelist(".");
          if (Find_Out_Supported_Images()<0) 
            {cout<<"No supported Images here\n";return;}
	      else 
	    {
	     gtk_widget_destroy(filew); 
	     gtk_main_quit();YES=1;};
      };
    };
    
    
    int f_select(int argc,char *argv[])
    {
        YES=0;
	gtk_init (&argc,&argv);
        filew = gtk_file_selection_new ("SView   ONLY select a >DIRECTORY<");
	
	gtk_signal_connect (GTK_OBJECT (filew), "destroy",
	     GtkSignalFunc (destroy), &filew);
	     
	gtk_signal_connect (GTK_OBJECT (GTK_FILE_SELECTION (filew)->ok_button),
	"clicked", GtkSignalFunc (for_me), filew);
 
 gtk_signal_connect_object(GTK_OBJECT(GTK_FILE_SELECTION(filew)->cancel_button),
    "clicked", GtkSignalFunc (gtk_widget_destroy),GTK_OBJECT (filew));
	
	gtk_widget_show(filew);
	gtk_main ();
	return 0;
    };
  	   
    
    
void action()
{
while(view.aview_quit!=1)
 { 
  if (SDL_PollEvent(&event))
  switch (event.type)
   {
   case SDL_KEYDOWN:
     switch(event.key.keysym.sym)
	    {
	     case  SDLK_LEFT:{
		    if (Imagelist_GoTo_prev()<0) break;
		    display_image(image_names->name);}
		  break;
	     case SDLK_ESCAPE:{view.aview_quit=1;}break;
	     case SDLK_RIGHT:{
	          //SDL_FreeSurface(screen);
		  if (Imagelist_GoTo_next()<0)break;
		   display_image(image_names->name);}
		  break;
	     case SDLK_SPACE:if(view.screenflags!=SDL_FULLSCREEN)
				{view.screenflags=SDL_FULLSCREEN;
				SDL_ShowCursor(SDL_DISABLE);
				//SDL_FreeSurface(image);
				//SDL_FreeSurface(screen);
				display_image(image_names->name);
				}
					else
				{view.screenflags=SDL_HWACCEL;
				SDL_ShowCursor(SDL_ENABLE);
				//SDL_FreeSurface(image);
				//SDL_FreeSurface(screen);
				display_image(image_names->name);
				}
		  break;
            }break;
   case SDL_MOUSEBUTTONDOWN:
       switch(event.button.button)
            {
	    case SDL_BUTTON_LEFT:{
	        if (Imagelist_GoTo_prev()<0) break;
     	        display_image(image_names->name);}
		break;
	    case SDL_BUTTON_MIDDLE:{view.aview_quit=1;}break;
	    case SDL_BUTTON_RIGHT:{
                   if (Imagelist_GoTo_next()<0)break;
        	   display_image(image_names->name);}
		break;
	    }break;
   case SDL_QUIT:
     { view.aview_quit=1;}break;
  };
 }; 
};



int main(int argc,char *argv[])
{
view.screenflags=SDL_HWACCEL;
 SDL_video_ini();
  Imagelist_first();
   f_select(argc,argv);
    if (YES==0) exit(0);
     view.aview_quit=0;
 //get the best video mode
     bestmode = SDL_GetVideoInfo();
     Imagelist_To_first(); 
 // show first image;
  display_image(image_names->name);
  SDL_ShowCursor(SDL_ENABLE);
 //main wait_event loop;
    action();
  Free_Imagelist();
  SDL_FreeSurface(image);
  SDL_FreeSurface(screen);
  SDL_Quit();
  return 0;
}